﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace InstanceTest
{
    class Car
    {
        //フィールド==========
        private int speed;      //スピード
        private double gas;     //ガソリン情報

        //メソッド==========
        //加速させるメソッド
        public void SpeedUp(int sp)
        {
            //ガソリンを減らす
            this.gas -= sp / 10.0;
            if(this.gas < 0)    //ガソリンがマイナスになる場合
            {
                //ガソリンを0に補正し、スピードを増やさない
                this.gas = 0;
            }
            else
            {
                //スピードを増やす
                this.speed += sp;
            }
        }

        //減速させるメソッド
        public void SpeedDown(int sp)
        {
            //スピードを減らす
            this.speed -= sp;
            if(this.speed < 0)  //スピードがマイナスになる場合
            {
                //スピードを0に補正する
                this.speed = 0;
            }
        }

        //初期化を行うメソッド
        public void Init(double gas)
        {
            this.speed = 0;
            this.gas = gas;
        }

        //スピードを取得する
        public int GetSpeed()
        {
            return this.speed;
        }

        //ガソリン量を取得する
        public double GetGas()
        {
            return this.gas;
        }

        //ガソリンを給油するメソッド
        public void SetGas()
        {
            //オーバーロードしているメソッドを呼び出す
            this.SetGas(20);
        }

        public void SetGas(double gas)
        {
            //止まっている場合は指定したガソリン量を給油
            if (this.speed == 0) 
            {                
                this.gas += gas;
            }
        }
    }
}
